diff --git a/net/ipv6/tcp_ipv6.c b/net/ipv6/tcp_ipv6.c
index 7ac2365aa6fb..e1130125c0f4 100644
--- a/net/ipv6/tcp_ipv6.c
+++ b/net/ipv6/tcp_ipv6.c
@@ -101,6 +101,10 @@ static void inet6_sk_rx_dst_set(struct sock *sk, const struct sk_buff *skb)
 	}
 }
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 static __u32 tcp_v6_init_sequence(const struct sk_buff *skb)
 {
 	return secure_tcpv6_sequence_number(ipv6_hdr(skb)->daddr.s6_addr32,
@@ -1311,6 +1315,9 @@ static int tcp_v6_do_rcv(struct sock *sk, struct sk_buff *skb)
 	return 0;
 
 reset:
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole)
+#endif
 	tcp_v6_send_reset(sk, skb);
 discard:
 	if (opt_skb)
@@ -1415,12 +1422,20 @@ static int tcp_v6_rcv(struct sk_buff *skb)
 	sk = __inet6_lookup_skb(&tcp_hashinfo, skb, __tcp_hdrlen(th),
 				th->source, th->dest, inet6_iif(skb),
 				&refcounted);
-	if (!sk)
+	if (!sk) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 1;
+#endif
 		goto no_tcp_socket;
+	}
 
 process:
-	if (sk->sk_state == TCP_TIME_WAIT)
+	if (sk->sk_state == TCP_TIME_WAIT) {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		ret = 2;
+#endif
 		goto do_time_wait;
+	}
 
 	if (sk->sk_state == TCP_NEW_SYN_RECV) {
 		struct request_sock *req = inet_reqsk(sk);
@@ -1510,6 +1525,10 @@ static int tcp_v6_rcv(struct sk_buff *skb)
 bad_packet:
 		__TCP_INC_STATS(net, TCP_MIB_INERRS);
 	} else {
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+		if (!grsec_enable_blackhole || (ret == 1 &&
+		    (skb->dev->flags & IFF_LOOPBACK)))
+#endif
 		tcp_v6_send_reset(NULL, skb);
 	}
 
diff --git a/net/ipv6/udp.c b/net/ipv6/udp.c
index 4db5f541bca6..9e628873a953 100644
--- a/net/ipv6/udp.c
+++ b/net/ipv6/udp.c
@@ -78,6 +78,10 @@ static u32 udp6_ehashfn(const struct net *net,
 			       udp_ipv6_hash_secret + net_hash_mix(net));
 }
 
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+extern int grsec_enable_blackhole;
+#endif
+
 static u32 udp6_portaddr_hash(const struct net *net,
 			      const struct in6_addr *addr6,
 			      unsigned int port)
@@ -380,7 +384,7 @@ int udpv6_recvmsg(struct sock *sk, struct msghdr *msg, size_t len,
 	if (unlikely(err)) {
 		trace_kfree_skb(skb, udpv6_recvmsg);
 		if (!peeked) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			if (is_udp4)
 				UDP_INC_STATS(sock_net(sk), UDP_MIB_INERRORS,
 					      is_udplite);
@@ -647,7 +651,7 @@ int udpv6_queue_rcv_skb(struct sock *sk, struct sk_buff *skb)
 	__UDP6_INC_STATS(sock_net(sk), UDP_MIB_CSUMERRORS, is_udplite);
 drop:
 	__UDP6_INC_STATS(sock_net(sk), UDP_MIB_INERRORS, is_udplite);
-	atomic_inc(&sk->sk_drops);
+	atomic_inc_unchecked(&sk->sk_drops);
 	kfree_skb(skb);
 	return -1;
 }
@@ -728,7 +732,7 @@ static int __udp6_lib_mcast_deliver(struct net *net, struct sk_buff *skb,
 		}
 		nskb = skb_clone(skb, GFP_ATOMIC);
 		if (unlikely(!nskb)) {
-			atomic_inc(&sk->sk_drops);
+			atomic_inc_unchecked(&sk->sk_drops);
 			__UDP6_INC_STATS(net, UDP_MIB_RCVBUFERRORS,
 					 IS_UDPLITE(sk));
 			__UDP6_INC_STATS(net, UDP_MIB_INERRORS,
@@ -846,6 +850,9 @@ int __udp6_lib_rcv(struct sk_buff *skb, struct udp_table *udptable,
 		goto csum_error;
 
 	__UDP6_INC_STATS(net, UDP_MIB_NOPORTS, proto == IPPROTO_UDPLITE);
+#ifdef CONFIG_GRKERNSEC_BLACKHOLE
+	if (!grsec_enable_blackhole || (skb->dev->flags & IFF_LOOPBACK))
+#endif
 	icmpv6_send(skb, ICMPV6_DEST_UNREACH, ICMPV6_PORT_UNREACH, 0);
 
 	kfree_skb(skb);
diff --git a/net/ipv6/xfrm6_mode_beet.c b/net/ipv6/xfrm6_mode_beet.c
index 1e205c3253ac..d71b84622d9c 100644
--- a/net/ipv6/xfrm6_mode_beet.c
+++ b/net/ipv6/xfrm6_mode_beet.c
@@ -37,7 +37,7 @@ static void xfrm6_beet_make_header(struct sk_buff *skb)
  *
  * The top IP header will be constructed per draft-nikander-esp-beet-mode-06.txt.
  */
-static int xfrm6_beet_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm6_beet_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct ipv6hdr *top_iph;
 	struct ip_beet_phdr *ph;
diff --git a/net/ipv6/xfrm6_mode_transport.c b/net/ipv6/xfrm6_mode_transport.c
index 1d3bbe6e1183..e0da42558bce 100644
--- a/net/ipv6/xfrm6_mode_transport.c
+++ b/net/ipv6/xfrm6_mode_transport.c
@@ -19,7 +19,7 @@
  * The IP header and mutable extension headers will be moved forward to make
  * space for the encapsulation header.
  */
-static int xfrm6_transport_output(struct xfrm_state *x, struct sk_buff *skb)
+static int __intentional_overflow(0) xfrm6_transport_output(struct xfrm_state *x, struct sk_buff *skb)
 {
 	struct ipv6hdr *iph;
 	u8 *prevhdr;
diff --git a/net/ipv6/xfrm6_policy.c b/net/ipv6/xfrm6_policy.c
index e0f71c01d728..9b71aad5eb7c 100644
--- a/net/ipv6/xfrm6_policy.c
+++ b/net/ipv6/xfrm6_policy.c
@@ -216,11 +216,11 @@ _decode_session6(struct sk_buff *skb, struct flowi *fl, int reverse)
 	}
 }
 
-static inline int xfrm6_garbage_collect(struct dst_ops *ops)
+static int xfrm6_garbage_collect(struct dst_ops *ops)
 {
 	struct net *net = container_of(ops, struct net, xfrm.xfrm6_dst_ops);
 
-	xfrm6_policy_afinfo.garbage_collect(net);
+	xfrm_garbage_collect_deferred(net);
 	return dst_entries_get_fast(ops) > ops->gc_thresh * 2;
 }
 
@@ -327,19 +327,19 @@ static struct ctl_table xfrm6_policy_table[] = {
 
 static int __net_init xfrm6_net_sysctl_init(struct net *net)
 {
-	struct ctl_table *table;
+	ctl_table_no_const *table = NULL;
 	struct ctl_table_header *hdr;
 
-	table = xfrm6_policy_table;
 	if (!net_eq(net, &init_net)) {
-		table = kmemdup(table, sizeof(xfrm6_policy_table), GFP_KERNEL);
+		table = kmemdup(xfrm6_policy_table, sizeof(xfrm6_policy_table), GFP_KERNEL);
 		if (!table)
 			goto err_alloc;
 
 		table[0].data = &net->xfrm.xfrm6_dst_ops.gc_thresh;
-	}
+		hdr = register_net_sysctl(net, "net/ipv6", table);
+	} else
+		hdr = register_net_sysctl(net, "net/ipv6", xfrm6_policy_table);
 
-	hdr = register_net_sysctl(net, "net/ipv6", table);
 	if (!hdr)
 		goto err_reg;
 
@@ -347,8 +347,7 @@ static int __net_init xfrm6_net_sysctl_init(struct net *net)
 	return 0;
 
 err_reg:
-	if (!net_eq(net, &init_net))
-		kfree(table);
+	kfree(table);
 err_alloc:
 	return -ENOMEM;
 }
diff --git a/net/ipx/ipx_proc.c b/net/ipx/ipx_proc.c
index c1d247ebe916..9e5949d06ef5 100644
--- a/net/ipx/ipx_proc.c
+++ b/net/ipx/ipx_proc.c
@@ -289,7 +289,7 @@ int __init ipx_proc_init(void)
 	struct proc_dir_entry *p;
 	int rc = -ENOMEM;
 
-	ipx_proc_dir = proc_mkdir("ipx", init_net.proc_net);
+	ipx_proc_dir = proc_mkdir_restrict("ipx", init_net.proc_net);
 
 	if (!ipx_proc_dir)
 		goto out;
diff --git a/net/irda/discovery.c b/net/irda/discovery.c
index 364d70aed068..c503f3fe94dd 100644
--- a/net/irda/discovery.c
+++ b/net/irda/discovery.c
@@ -136,7 +136,7 @@ void irlmp_add_discovery_log(hashbin_t *cachelog, hashbin_t *log)
 	}
 
 	/* Delete the now empty log */
-	hashbin_delete(log, (FREE_FUNC) kfree);
+	hashbin_delete(log, irlmp_kfree);
 }
 
 /*
diff --git a/net/irda/ircomm/ircomm_core.c b/net/irda/ircomm/ircomm_core.c
index 3af219545f6d..a38e80492ac4 100644
--- a/net/irda/ircomm/ircomm_core.c
+++ b/net/irda/ircomm/ircomm_core.c
@@ -46,7 +46,7 @@
 #include <net/irda/ircomm_param.h>
 #include <net/irda/ircomm_core.h>
 
-static int __ircomm_close(struct ircomm_cb *self);
+static void __ircomm_close(void *_self);
 static void ircomm_control_indication(struct ircomm_cb *self,
 				      struct sk_buff *skb, int clen);
 
@@ -91,7 +91,7 @@ static int __init ircomm_init(void)
 
 static void __exit ircomm_cleanup(void)
 {
-	hashbin_delete(ircomm, (FREE_FUNC) __ircomm_close);
+	hashbin_delete(ircomm, __ircomm_close);
 
 #ifdef CONFIG_PROC_FS
 	remove_proc_entry("ircomm", proc_irda);
@@ -151,8 +151,10 @@ EXPORT_SYMBOL(ircomm_open);
  *    Remove IrCOMM instance
  *
  */
-static int __ircomm_close(struct ircomm_cb *self)
+static void __ircomm_close(void *_self)
 {
+	struct ircomm_cb *self = _self;
+
 	/* Disconnect link if any */
 	ircomm_do_event(self, IRCOMM_DISCONNECT_REQUEST, NULL, NULL);
 
@@ -170,8 +172,6 @@ static int __ircomm_close(struct ircomm_cb *self)
 	self->magic = 0;
 
 	kfree(self);
-
-	return 0;
 }
 
 /*
@@ -191,7 +191,8 @@ int ircomm_close(struct ircomm_cb *self)
 
 	IRDA_ASSERT(entry == self, return -1;);
 
-	return __ircomm_close(self);
+	__ircomm_close(self);
+	return 0;
 }
 
 EXPORT_SYMBOL(ircomm_close);
diff --git a/net/irda/ircomm/ircomm_tty.c b/net/irda/ircomm/ircomm_tty.c
index 873c4b707d6a..6d3624f10eba 100644
--- a/net/irda/ircomm/ircomm_tty.c
+++ b/net/irda/ircomm/ircomm_tty.c
@@ -172,8 +172,10 @@ static int __init ircomm_tty_init(void)
 	return 0;
 }
 
-static void __exit __ircomm_tty_cleanup(struct ircomm_tty_cb *self)
+static void __exit __ircomm_tty_cleanup(void *_self)
 {
+	struct ircomm_tty_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == IRCOMM_TTY_MAGIC, return;);
 
@@ -201,7 +203,7 @@ static void __exit ircomm_tty_cleanup(void)
 		return;
 	}
 
-	hashbin_delete(ircomm_tty, (FREE_FUNC) __ircomm_tty_cleanup);
+	hashbin_delete(ircomm_tty, __ircomm_tty_cleanup);
 	put_tty_driver(driver);
 }
 
@@ -311,10 +313,10 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 	add_wait_queue(&port->open_wait, &wait);
 
 	pr_debug("%s(%d):block_til_ready before block on %s open_count=%d\n",
-		 __FILE__, __LINE__, tty->driver->name, port->count);
+		 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 	spin_lock_irqsave(&port->lock, flags);
-	port->count--;
+	atomic_dec(&port->count);
 	port->blocked_open++;
 	spin_unlock_irqrestore(&port->lock, flags);
 
@@ -347,7 +349,7 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 		}
 
 		pr_debug("%s(%d):block_til_ready blocking on %s open_count=%d\n",
-			 __FILE__, __LINE__, tty->driver->name, port->count);
+			 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 		schedule();
 	}
@@ -357,12 +359,12 @@ static int ircomm_tty_block_til_ready(struct ircomm_tty_cb *self,
 
 	spin_lock_irqsave(&port->lock, flags);
 	if (!tty_hung_up_p(filp))
-		port->count++;
+		atomic_inc(&port->count);
 	port->blocked_open--;
 	spin_unlock_irqrestore(&port->lock, flags);
 
 	pr_debug("%s(%d):block_til_ready after blocking on %s open_count=%d\n",
-		 __FILE__, __LINE__, tty->driver->name, port->count);
+		 __FILE__, __LINE__, tty->driver->name, atomic_read(&port->count));
 
 	if (!retval)
 		tty_port_set_active(port, 1);
@@ -432,12 +434,12 @@ static int ircomm_tty_open(struct tty_struct *tty, struct file *filp)
 
 	/* ++ is not atomic, so this should be protected - Jean II */
 	spin_lock_irqsave(&self->port.lock, flags);
-	self->port.count++;
+	atomic_inc(&self->port.count);
 	spin_unlock_irqrestore(&self->port.lock, flags);
 	tty_port_tty_set(&self->port, tty);
 
 	pr_debug("%s(), %s%d, count = %d\n", __func__ , tty->driver->name,
-		 self->line, self->port.count);
+		 self->line, atomic_read(&self->port.count));
 
 	/* Not really used by us, but lets do it anyway */
 	self->port.low_latency = (self->port.flags & ASYNC_LOW_LATENCY) ? 1 : 0;
@@ -931,7 +933,7 @@ static void ircomm_tty_hangup(struct tty_struct *tty)
 		tty_kref_put(port->tty);
 	}
 	port->tty = NULL;
-	port->count = 0;
+	atomic_set(&port->count, 0);
 	spin_unlock_irqrestore(&port->lock, flags);
 	tty_port_set_active(port, 0);
 
@@ -1275,7 +1277,7 @@ static void ircomm_tty_line_info(struct ircomm_tty_cb *self, struct seq_file *m)
 	seq_putc(m, '\n');
 
 	seq_printf(m, "Role: %s\n", self->client ? "client" : "server");
-	seq_printf(m, "Open count: %d\n", self->port.count);
+	seq_printf(m, "Open count: %d\n", atomic_read(&self->port.count));
 	seq_printf(m, "Max data size: %d\n", self->max_data_size);
 	seq_printf(m, "Max header size: %d\n", self->max_header_size);
 
diff --git a/net/irda/ircomm/ircomm_tty_attach.c b/net/irda/ircomm/ircomm_tty_attach.c
index 0a411019c098..e811c2eff389 100644
--- a/net/irda/ircomm/ircomm_tty_attach.c
+++ b/net/irda/ircomm/ircomm_tty_attach.c
@@ -52,7 +52,7 @@ static void ircomm_tty_getvalue_confirm(int result, __u16 obj_id,
 					struct ias_value *value, void *priv);
 static void ircomm_tty_start_watchdog_timer(struct ircomm_tty_cb *self,
 					    int timeout);
-static void ircomm_tty_watchdog_timer_expired(void *data);
+static void ircomm_tty_watchdog_timer_expired(unsigned long data);
 
 static int ircomm_tty_state_idle(struct ircomm_tty_cb *self,
 				 IRCOMM_TTY_EVENT event,
@@ -597,7 +597,7 @@ static void ircomm_tty_start_watchdog_timer(struct ircomm_tty_cb *self,
  *    Called when the connect procedure have taken to much time.
  *
  */
-static void ircomm_tty_watchdog_timer_expired(void *data)
+static void ircomm_tty_watchdog_timer_expired(unsigned long data)
 {
 	struct ircomm_tty_cb *self = (struct ircomm_tty_cb *) data;
 
diff --git a/net/irda/irda_device.c b/net/irda/irda_device.c
index 856736656a30..7c8aa51732de 100644
--- a/net/irda/irda_device.c
+++ b/net/irda/irda_device.c
@@ -52,12 +52,12 @@
 #include <net/irda/timer.h>
 #include <net/irda/wrapper.h>
 
-static void __irda_task_delete(struct irda_task *task);
+static void __irda_task_delete(void *_task);
 
 static hashbin_t *dongles = NULL;
 static hashbin_t *tasks = NULL;
 
-static void irda_task_timer_expired(void *data);
+static void irda_task_timer_expired(unsigned long data);
 
 int __init irda_device_init( void)
 {
@@ -90,7 +90,7 @@ static void leftover_dongle(void *arg)
 
 void irda_device_cleanup(void)
 {
-	hashbin_delete(tasks, (FREE_FUNC) __irda_task_delete);
+	hashbin_delete(tasks, __irda_task_delete);
 
 	hashbin_delete(dongles, leftover_dongle);
 }
@@ -159,8 +159,10 @@ int irda_device_is_receiving(struct net_device *dev)
 	return req.ifr_receiving;
 }
 
-static void __irda_task_delete(struct irda_task *task)
+static void __irda_task_delete(void *_task)
 {
+	struct irda_task *task = _task;
+
 	del_timer(&task->timer);
 
 	kfree(task);
@@ -249,11 +251,11 @@ static int irda_task_kick(struct irda_task *task)
  *    Task time has expired. We now try to execute task (again), and restart
  *    the timer if the task has not finished yet
  */
-static void irda_task_timer_expired(void *data)
+static void irda_task_timer_expired(unsigned long data)
 {
 	struct irda_task *task;
 
-	task = data;
+	task = (struct irda_task *)data;
 
 	irda_task_kick(task);
 }
diff --git a/net/irda/iriap.c b/net/irda/iriap.c
index 1138eaf5c682..cb1900c8a4a2 100644
--- a/net/irda/iriap.c
+++ b/net/irda/iriap.c
@@ -61,7 +61,7 @@ static const char *const ias_charset_types[] __maybe_unused = {
 static hashbin_t *iriap = NULL;
 static void *service_handle;
 
-static void __iriap_close(struct iriap_cb *self);
+static void __iriap_close(void *_self);
 static int iriap_register_lsap(struct iriap_cb *self, __u8 slsap_sel, int mode);
 static void iriap_disconnect_indication(void *instance, void *sap,
 					LM_REASON reason, struct sk_buff *skb);
@@ -76,7 +76,7 @@ static void iriap_connect_confirm(void *instance, void *sap,
 static int iriap_data_indication(void *instance, void *sap,
 				 struct sk_buff *skb);
 
-static void iriap_watchdog_timer_expired(void *data);
+static void iriap_watchdog_timer_expired(unsigned long data);
 
 static inline void iriap_start_watchdog_timer(struct iriap_cb *self,
 					      int timeout)
@@ -161,8 +161,8 @@ void iriap_cleanup(void)
 {
 	irlmp_unregister_service(service_handle);
 
-	hashbin_delete(iriap, (FREE_FUNC) __iriap_close);
-	hashbin_delete(irias_objects, (FREE_FUNC) __irias_delete_object);
+	hashbin_delete(iriap, __iriap_close);
+	hashbin_delete(irias_objects, __irias_delete_object);
 }
 
 /*
@@ -219,8 +219,10 @@ EXPORT_SYMBOL(iriap_open);
  *    Removes (deallocates) the IrIAP instance
  *
  */
-static void __iriap_close(struct iriap_cb *self)
+static void __iriap_close(void *_self)
 {
+	struct iriap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == IAS_MAGIC, return;);
 
@@ -946,7 +948,7 @@ void iriap_call_indication(struct iriap_cb *self, struct sk_buff *skb)
  *    Query has taken too long time, so abort
  *
  */
-static void iriap_watchdog_timer_expired(void *data)
+static void iriap_watchdog_timer_expired(unsigned long data)
 {
 	struct iriap_cb *self = (struct iriap_cb *) data;
 
diff --git a/net/irda/irias_object.c b/net/irda/irias_object.c
index 53b86d0e1630..5b884f341d20 100644
--- a/net/irda/irias_object.c
+++ b/net/irda/irias_object.c
@@ -88,8 +88,10 @@ EXPORT_SYMBOL(irias_new_object);
  *    Delete given attribute and deallocate all its memory
  *
  */
-static void __irias_delete_attrib(struct ias_attrib *attrib)
+static void __irias_delete_attrib(void *_attrib)
 {
+	struct ias_attrib *attrib = _attrib;
+
 	IRDA_ASSERT(attrib != NULL, return;);
 	IRDA_ASSERT(attrib->magic == IAS_ATTRIB_MAGIC, return;);
 
@@ -101,14 +103,16 @@ static void __irias_delete_attrib(struct ias_attrib *attrib)
 	kfree(attrib);
 }
 
-void __irias_delete_object(struct ias_object *obj)
+void __irias_delete_object(void *_obj)
 {
+	struct ias_object *obj = _obj;
+
 	IRDA_ASSERT(obj != NULL, return;);
 	IRDA_ASSERT(obj->magic == IAS_OBJECT_MAGIC, return;);
 
 	kfree(obj->name);
 
-	hashbin_delete(obj->attribs, (FREE_FUNC) __irias_delete_attrib);
+	hashbin_delete(obj->attribs, __irias_delete_attrib);
 
 	obj->magic = ~IAS_OBJECT_MAGIC;
 
diff --git a/net/irda/irlan/irlan_client.c b/net/irda/irlan/irlan_client.c
index c5837a40c78e..518b358ecc0c 100644
--- a/net/irda/irlan/irlan_client.c
+++ b/net/irda/irlan/irlan_client.c
@@ -68,7 +68,7 @@ static void irlan_check_response_param(struct irlan_cb *self, char *param,
 				       char *value, int val_len);
 static void irlan_client_open_ctrl_tsap(struct irlan_cb *self);
 
-static void irlan_client_kick_timer_expired(void *data)
+static void irlan_client_kick_timer_expired(unsigned long data)
 {
 	struct irlan_cb *self = (struct irlan_cb *) data;
 
diff --git a/net/irda/irlap.c b/net/irda/irlap.c
index 1cde711bcab5..d05a5fbe479a 100644
--- a/net/irda/irlap.c
+++ b/net/irda/irlap.c
@@ -56,7 +56,7 @@ int sysctl_slot_timeout = SLOT_TIMEOUT * 1000 / HZ;
 int sysctl_warn_noreply_time = 3;
 
 extern void irlap_queue_xmit(struct irlap_cb *self, struct sk_buff *skb);
-static void __irlap_close(struct irlap_cb *self);
+static void __irlap_close(void *_self);
 static void irlap_init_qos_capabilities(struct irlap_cb *self,
 					struct qos_info *qos_user);
 
@@ -95,7 +95,7 @@ void irlap_cleanup(void)
 {
 	IRDA_ASSERT(irlap != NULL, return;);
 
-	hashbin_delete(irlap, (FREE_FUNC) __irlap_close);
+	hashbin_delete(irlap, __irlap_close);
 }
 
 /*
@@ -177,8 +177,10 @@ EXPORT_SYMBOL(irlap_open);
  *    Remove IrLAP and all allocated memory. Stop any pending timers.
  *
  */
-static void __irlap_close(struct irlap_cb *self)
+static void __irlap_close(void *_self)
 {
+	struct irlap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == LAP_MAGIC, return;);
 
@@ -482,6 +484,11 @@ void irlap_disconnect_indication(struct irlap_cb *self, LAP_REASON reason)
  *    Start one single discovery operation.
  *
  */
+static void irlap_kfree(void *arg)
+{
+	kfree(arg);
+}
+
 void irlap_discovery_request(struct irlap_cb *self, discovery_t *discovery)
 {
 	struct irlap_info info;
@@ -513,7 +520,7 @@ void irlap_discovery_request(struct irlap_cb *self, discovery_t *discovery)
 	/* Check if last discovery request finished in time, or if
 	 * it was aborted due to the media busy flag. */
 	if (self->discovery_log != NULL) {
-		hashbin_delete(self->discovery_log, (FREE_FUNC) kfree);
+		hashbin_delete(self->discovery_log, irlap_kfree);
 		self->discovery_log = NULL;
 	}
 
diff --git a/net/irda/irlap_event.c b/net/irda/irlap_event.c
index 0e1b4d79f745..7e39b1270529 100644
--- a/net/irda/irlap_event.c
+++ b/net/irda/irlap_event.c
@@ -163,7 +163,7 @@ static int (*state[])(struct irlap_cb *self, IRLAP_EVENT event,
  *    Poll timer has expired. Normally we must now send a RR frame to the
  *    remote device
  */
-static void irlap_poll_timer_expired(void *data)
+static void irlap_poll_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
diff --git a/net/irda/irlmp.c b/net/irda/irlmp.c
index 43964594aa12..cbf44c25b771 100644
--- a/net/irda/irlmp.c
+++ b/net/irda/irlmp.c
@@ -125,6 +125,11 @@ int __init irlmp_init(void)
  *    Remove IrLMP layer
  *
  */
+void irlmp_kfree(void *arg)
+{
+	kfree(arg);
+}
+
 void irlmp_cleanup(void)
 {
 	/* Check for main structure */
@@ -133,11 +138,11 @@ void irlmp_cleanup(void)
 
 	del_timer(&irlmp->discovery_timer);
 
-	hashbin_delete(irlmp->links, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->unconnected_lsaps, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->clients, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->services, (FREE_FUNC) kfree);
-	hashbin_delete(irlmp->cachelog, (FREE_FUNC) kfree);
+	hashbin_delete(irlmp->links, irlmp_kfree);
+	hashbin_delete(irlmp->unconnected_lsaps, irlmp_kfree);
+	hashbin_delete(irlmp->clients, irlmp_kfree);
+	hashbin_delete(irlmp->services, irlmp_kfree);
+	hashbin_delete(irlmp->cachelog, irlmp_kfree);
 
 	/* De-allocate main structure */
 	kfree(irlmp);
@@ -204,8 +209,10 @@ EXPORT_SYMBOL(irlmp_open_lsap);
  *
  *    Remove an instance of LSAP
  */
-static void __irlmp_close_lsap(struct lsap_cb *self)
+static void __irlmp_close_lsap(void *_self)
 {
+	struct lsap_cb *self = _self;
+
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == LMP_LSAP_MAGIC, return;);
 
@@ -354,7 +361,7 @@ void irlmp_unregister_link(__u32 saddr)
 		/* Final cleanup */
 		del_timer(&link->idle_timer);
 		link->magic = 0;
-		hashbin_delete(link->lsaps, (FREE_FUNC) __irlmp_close_lsap);
+		hashbin_delete(link->lsaps, __irlmp_close_lsap);
 		kfree(link);
 	}
 }
diff --git a/net/irda/irlmp_event.c b/net/irda/irlmp_event.c
index e306cf2c1e04..e6e0e904262e 100644
--- a/net/irda/irlmp_event.c
+++ b/net/irda/irlmp_event.c
@@ -165,7 +165,7 @@ void irlmp_do_lap_event(struct lap_cb *self, IRLMP_EVENT event,
 	(*lap_state[self->lap_state]) (self, event, skb);
 }
 
-void irlmp_discovery_timer_expired(void *data)
+void irlmp_discovery_timer_expired(unsigned long data)
 {
 	/* We always cleanup the log (active & passive discovery) */
 	irlmp_do_expiry();
@@ -176,7 +176,7 @@ void irlmp_discovery_timer_expired(void *data)
 	irlmp_start_discovery_timer(irlmp, sysctl_discovery_timeout * HZ);
 }
 
-void irlmp_watchdog_timer_expired(void *data)
+void irlmp_watchdog_timer_expired(unsigned long data)
 {
 	struct lsap_cb *self = (struct lsap_cb *) data;
 
@@ -186,7 +186,7 @@ void irlmp_watchdog_timer_expired(void *data)
 	irlmp_do_lsap_event(self, LM_WATCHDOG_TIMEOUT, NULL);
 }
 
-void irlmp_idle_timer_expired(void *data)
+void irlmp_idle_timer_expired(unsigned long data)
 {
 	struct lap_cb *self = (struct lap_cb *) data;
 
diff --git a/net/irda/irnet/irnet.h b/net/irda/irnet/irnet.h
index 8d65bb9477fc..677364be99ee 100644
--- a/net/irda/irnet/irnet.h
+++ b/net/irda/irnet/irnet.h
@@ -511,7 +511,7 @@ typedef struct irnet_ctrl_channel
 /* -------------------------- IRDA PART -------------------------- */
 int irda_irnet_create(irnet_socket *);	/* Initialise an IrNET socket */
 int irda_irnet_connect(irnet_socket *);	/* Try to connect over IrDA */
-void irda_irnet_destroy(irnet_socket *);	/* Teardown an IrNET socket */
+void irda_irnet_destroy(void *);	/* Teardown an IrNET socket */
 int irda_irnet_init(void);		/* Initialise IrDA part of IrNET */
 void irda_irnet_cleanup(void);		/* Teardown IrDA part of IrNET */
 
diff --git a/net/irda/irnet/irnet_irda.c b/net/irda/irnet/irnet_irda.c
index 7f17a8020e8a..98575e102327 100644
--- a/net/irda/irnet/irnet_irda.c
+++ b/net/irda/irnet/irnet_irda.c
@@ -613,8 +613,10 @@ irda_irnet_connect(irnet_socket *	self)
  * Note : this need to be called from a process context.
  */
 void
-irda_irnet_destroy(irnet_socket *	self)
+irda_irnet_destroy(void *_self)
 {
+  irnet_socket *self = _self;
+
   DENTER(IRDA_SOCK_TRACE, "(self=0x%p)\n", self);
   if(self == NULL)
     return;
@@ -1879,7 +1881,7 @@ irda_irnet_cleanup(void)
   irnet_destroy_server();
 
   /* Remove all instances of IrNET socket still present */
-  hashbin_delete(irnet_server.list, (FREE_FUNC) irda_irnet_destroy);
+  hashbin_delete(irnet_server.list, irda_irnet_destroy);
 
   DEXIT(MODULE_TRACE, "\n");
 }
diff --git a/net/irda/irproc.c b/net/irda/irproc.c
index b9ac598e2116..f88cc5627cf9 100644
--- a/net/irda/irproc.c
+++ b/net/irda/irproc.c
@@ -66,7 +66,7 @@ void __init irda_proc_register(void)
 {
 	int i;
 
-	proc_irda = proc_mkdir("irda", init_net.proc_net);
+	proc_irda = proc_mkdir_restrict("irda", init_net.proc_net);
 	if (proc_irda == NULL)
 		return;
 
diff --git a/net/irda/irttp.c b/net/irda/irttp.c
index b6ab41d5b3a3..e2263ce4ba71 100644
--- a/net/irda/irttp.c
+++ b/net/irda/irttp.c
@@ -42,7 +42,7 @@
 
 static struct irttp_cb *irttp;
 
-static void __irttp_close_tsap(struct tsap_cb *self);
+static void __irttp_close_tsap(void *_self);
 
 static int irttp_data_indication(void *instance, void *sap,
 				 struct sk_buff *skb);
@@ -121,7 +121,7 @@ void irttp_cleanup(void)
 	/*
 	 *  Delete hashbin and close all TSAP instances in it
 	 */
-	hashbin_delete(irttp->tsaps, (FREE_FUNC) __irttp_close_tsap);
+	hashbin_delete(irttp->tsaps, __irttp_close_tsap);
 
 	irttp->magic = 0;
 
@@ -469,8 +469,10 @@ EXPORT_SYMBOL(irttp_open_tsap);
  *    deallocation of the TSAP, and resetting of the TSAPs values;
  *
  */
-static void __irttp_close_tsap(struct tsap_cb *self)
+static void __irttp_close_tsap(void *_self)
 {
+	struct tsap_cb *self = _self;
+
 	/* First make sure we're connected. */
 	IRDA_ASSERT(self != NULL, return;);
 	IRDA_ASSERT(self->magic == TTP_TSAP_MAGIC, return;);
diff --git a/net/irda/timer.c b/net/irda/timer.c
index f2280f73b057..c0a006fa77e3 100644
--- a/net/irda/timer.c
+++ b/net/irda/timer.c
@@ -34,12 +34,12 @@
 
 extern int  sysctl_slot_timeout;
 
-static void irlap_slot_timer_expired(void* data);
-static void irlap_query_timer_expired(void* data);
-static void irlap_final_timer_expired(void* data);
-static void irlap_wd_timer_expired(void* data);
-static void irlap_backoff_timer_expired(void* data);
-static void irlap_media_busy_expired(void* data);
+static void irlap_slot_timer_expired(unsigned long data);
+static void irlap_query_timer_expired(unsigned long data);
+static void irlap_final_timer_expired(unsigned long data);
+static void irlap_wd_timer_expired(unsigned long data);
+static void irlap_backoff_timer_expired(unsigned long data);
+static void irlap_media_busy_expired(unsigned long data);
 
 void irlap_start_slot_timer(struct irlap_cb *self, int timeout)
 {
@@ -138,7 +138,7 @@ void irlmp_stop_idle_timer(struct lap_cb *self)
  *    IrLAP slot timer has expired
  *
  */
-static void irlap_slot_timer_expired(void *data)
+static void irlap_slot_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -154,7 +154,7 @@ static void irlap_slot_timer_expired(void *data)
  *    IrLAP query timer has expired
  *
  */
-static void irlap_query_timer_expired(void *data)
+static void irlap_query_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -170,7 +170,7 @@ static void irlap_query_timer_expired(void *data)
  *
  *
  */
-static void irlap_final_timer_expired(void *data)
+static void irlap_final_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -186,7 +186,7 @@ static void irlap_final_timer_expired(void *data)
  *
  *
  */
-static void irlap_wd_timer_expired(void *data)
+static void irlap_wd_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -202,7 +202,7 @@ static void irlap_wd_timer_expired(void *data)
  *
  *
  */
-static void irlap_backoff_timer_expired(void *data)
+static void irlap_backoff_timer_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
@@ -218,7 +218,7 @@ static void irlap_backoff_timer_expired(void *data)
  *
  *
  */
-static void irlap_media_busy_expired(void *data)
+static void irlap_media_busy_expired(unsigned long data)
 {
 	struct irlap_cb *self = (struct irlap_cb *) data;
 
diff --git a/net/iucv/af_iucv.c b/net/iucv/af_iucv.c
index 91cbbf1c3f82..f2fd5810bf2c 100644
--- a/net/iucv/af_iucv.c
+++ b/net/iucv/af_iucv.c
@@ -688,10 +688,10 @@ static void __iucv_auto_name(struct iucv_sock *iucv)
 {
 	char name[12];
 
-	sprintf(name, "%08x", atomic_inc_return(&iucv_sk_list.autobind_name));
+	sprintf(name, "%08x", atomic_inc_return_unchecked(&iucv_sk_list.autobind_name));
 	while (__iucv_get_sock_by_name(name)) {
 		sprintf(name, "%08x",
-			atomic_inc_return(&iucv_sk_list.autobind_name));
+			atomic_inc_return_unchecked(&iucv_sk_list.autobind_name));
 	}
 	memcpy(iucv->src_name, name, 8);
 }
@@ -1353,7 +1353,7 @@ static int iucv_sock_recvmsg(struct socket *sock, struct msghdr *msg,
 	unsigned int copied, rlen;
 	struct sk_buff *skb, *rskb, *cskb;
 	int err = 0;
-	u32 offset;
+	u32 offset, class;
 
 	if ((sk->sk_state == IUCV_DISCONN) &&
 	    skb_queue_empty(&iucv->backlog_skb_q) &&
@@ -1397,9 +1397,8 @@ static int iucv_sock_recvmsg(struct socket *sock, struct msghdr *msg,
 	/* create control message to store iucv msg target class:
 	 * get the trgcls from the control buffer of the skb due to
 	 * fragmentation of original iucv message. */
-	err = put_cmsg(msg, SOL_IUCV, SCM_IUCV_TRGCLS,
-		       sizeof(IUCV_SKB_CB(skb)->class),
-		       (void *)&IUCV_SKB_CB(skb)->class);
+	class = IUCV_SKB_CB(skb)->class;
+	err = put_cmsg(msg, SOL_IUCV, SCM_IUCV_TRGCLS, sizeof(class), &class);
 	if (err) {
 		if (!(flags & MSG_PEEK))
 			skb_queue_head(&sk->sk_receive_queue, skb);
diff --git a/net/iucv/iucv.c b/net/iucv/iucv.c
index 88a2a3ba4212..db2037a7551d 100644
--- a/net/iucv/iucv.c
+++ b/net/iucv/iucv.c
@@ -720,7 +720,7 @@ static int iucv_cpu_notify(struct notifier_block *self,
 	return NOTIFY_OK;
 }
 
-static struct notifier_block __refdata iucv_cpu_notifier = {
+static struct notifier_block iucv_cpu_notifier = {
 	.notifier_call = iucv_cpu_notify,
 };
 
diff --git a/net/key/af_key.c b/net/key/af_key.c
index 94bf810ad242..d7a2b64374ea 100644
--- a/net/key/af_key.c
+++ b/net/key/af_key.c
@@ -3096,10 +3096,10 @@ static int pfkey_send_policy_notify(struct xfrm_policy *xp, int dir, const struc
 static u32 get_acqseq(void)
 {
 	u32 res;
-	static atomic_t acqseq;
+	static atomic_unchecked_t acqseq;
 
 	do {
-		res = atomic_inc_return(&acqseq);
+		res = atomic_inc_return_unchecked(&acqseq);
 	} while (!res);
 	return res;
 }
